Subject: configure spaghetti code

From: Florian Lohoff <[email-masked]>
Date: Sat, 1 Apr 2000 18:19:31 +0200

Hi,
i tried to compile my own kernel for the IP22 (mips not mips64) and 
had no sucess (no output on any console) - I think this is due
to the a couple of bugs ...

First of all - The spaghetti code in the config.in contains a lot if nice
gimmicks like:

if [ "$CONFIG_DECSTATION" != "y" ]; then
   source drivers/char/Config.in
else
   mainmenu_option next_comment
   comment 'DECstation Character devices'
[...]
   if [ "$CONFIG_SGI_IP22" = "y" ]; then
      bool 'SGI PROM Console Support' CONFIG_SGI_PROM_CONSOLE
   fi
[...]

Due to this the CONFIG_SGI_PROM_CONSOLE is not even selectable if
i do not enable CONFIG_DECSTATION with CONFIG_SGI_IP22 ...

As most of the Architectures (IP22, Decstation etc) have VERY special
hardware and nothing in common with the "default pc architecture"
wouldnt it be a good way to 

1. Have a choice of ONE architecture to select (Most of them can coexist
   within the same kernel)
2. Depending on the selected Architecture include "config" scripts
   within their special directory (Probably common CPU Type and networking
   option, filesystem selection)
3. Only show devices which are really available for the architectures
   (I dont think anyone has succeeded in plugging a 3C509 into a DecStation 
   5000 or a Telephony card or even IDE)

Flo
-- 
Florian Lohoff		[email-masked]		      	+49-5241-470566
"Technology is a constant battle between manufacturers producing bigger and
more idiot-proof systems and nature producing bigger and better idiots."

---

From: Ralf Baechle <[email-masked]>
Date: Sun, 2 Apr 2000 05:16:26 +0200

> 1. Have a choice of ONE architecture to select (Most of them can coexist

Most of them can NOT coexist in one kernel due to address space layout
differences, firmware differences etc. and users can not be expected to
know the details nor is it realistic to make a generic kernel for MIPS.
So as you say there should only one be selectable.

>    5000 or a Telephony card or even IDE)

Patches will be accepted :-)  Actually in the past things were slightly
more as you were suggesting but the code was fairly spagetty-like with the
intension to redo it somewhen.

  Ralf

---

From: Geert Uytterhoeven <[email-masked]>
Date: Mon, 3 Apr 2000 10:21:20 +0200 (MET DST)

>    5000 or a Telephony card or even IDE)

If you configure for a DS5000, you won't have ISA, and the 3c509 question
should depend on CONFIG_ISA (which was added very recently, so probably the ISA
questions aren't protected by CONFIG_ISA yet).

Gr{oetje,eeting}s,

						Geert

--
Geert Uytterhoeven ------------- Sony Software Development Center Europe (SDCE)
[email-masked] ------------------- Sint-Stevens-Woluwestraat 55
Voice +32-2-7248638 Fax +32-2-7262686 ---------------- B-1130 Brussels, Belgium